'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Loader = function (_Component) {
    _inherits(Loader, _Component);

    function Loader() {
        _classCallCheck(this, Loader);

        return _possibleConstructorReturn(this, (Loader.__proto__ || Object.getPrototypeOf(Loader)).apply(this, arguments));
    }

    _createClass(Loader, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            var _props = this.props,
                loadId = _props.loadId,
                shouldLoad = _props.shouldLoad,
                load = _props.load,
                asyncIsLoading = _props.asyncIsLoading,
                asyncSetStatus = _props.asyncSetStatus;

            if (shouldLoad(this.props) && !asyncIsLoading) {
                asyncSetStatus(loadId, { loading: true });
                var p = load(this.props);
                if ((typeof p === 'undefined' ? 'undefined' : _typeof(p)) === 'object' && typeof p.then === 'function') {
                    p.then(function () {
                        return asyncSetStatus(loadId, { loading: false });
                    });
                }
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(props) {
            var shouldReload = props.shouldReload,
                load = props.load,
                asyncIsLoading = props.asyncIsLoading;

            return !asyncIsLoading && shouldReload(props, this.props) && load(props);
        }
    }, {
        key: 'render',
        value: function render() {
            var _props2 = this.props,
                children = _props2.children,
                render = _props2.render;

            var props = _extends({}, this.props);
            ['children', 'render', 'load', 'shouldLoad', 'loadId'].forEach(function (k) {
                return delete props[k];
            });
            if (render) {
                return render(props);
            }
            return _react2.default.cloneElement(Array.isArray(children) ? children[0] : _react2.default.Children.only(children), props);
        }
    }]);

    return Loader;
}(_react.Component);

Loader.propTypes = {
    loadId: _propTypes2.default.string.isRequired,
    shouldLoad: _propTypes2.default.func.isRequired,
    load: _propTypes2.default.func.isRequired,
    shouldReload: _propTypes2.default.func.isRequired,
    render: _propTypes2.default.func,

    //redux component specific props
    asyncIsLoading: _propTypes2.default.bool.isRequired,
    asyncSetStatus: _propTypes2.default.func.isRequired
};
exports.default = Loader;