'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.reducer = exports.action = exports.ReduxLoader = exports.Loader = exports.renderAsync = exports.stateSelector = exports.isReady = undefined;

var _Container = require('./Container');

var _Container2 = _interopRequireDefault(_Container);

var _Loader = require('./Loader');

var _Loader2 = _interopRequireDefault(_Loader);

var _action = require('./action');

var _action2 = _interopRequireDefault(_action);

var _reducer = require('./reducer');

var _reducer2 = _interopRequireDefault(_reducer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isReady = exports.isReady = function isReady(state) {
    if (!state) {
        throw new Error('isReady first args must be an existing state');
    }
    if (!Object.keys(state).filter(function (k) {
        return state[k].loading;
    }).length) {
        return true;
    }
    return false;
};

var stateSelector = exports.stateSelector = function stateSelector(key, state) {
    return state[key];
};

var renderAsync = exports.renderAsync = function renderAsync(store, render) {
    var stateKey = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'asyncLoad';

    var asyncComponentsState = void 0;
    var html = void 0;
    return new Promise(function (ok) {
        var subscriber = store.subscribe(function () {
            var previousState = asyncComponentsState;
            asyncComponentsState = stateSelector(stateKey, store.getState());
            if (!!previousState && previousState !== asyncComponentsState && isReady(asyncComponentsState)) {
                html = render();
                subscriber();
                return ok(html);
            }
        });
        html = render();
        if (isReady(stateSelector(stateKey, store.getState()))) {
            subscriber();
            return ok(html);
        }
    });
};

exports.Loader = _Loader2.default;
exports.ReduxLoader = _Container2.default;
exports.action = _action2.default;
exports.reducer = _reducer2.default;